SystemOrganization addCategory: #'OMeta2-Exp'!

OMeta2 subclass: #LSystem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2-Exp'!

!LSystem commentStamp: 'sn 9/16/2014 17:09' prior: 0!
TurtleSimple initialize.

"Koch snowflake"

|tree frac|
tree := LSystem matchAll: '5; F=F-F++F-F; G=; F++F++F' with: #start.  
frac := LSystemGen matchAll: tree with: #gen.
TurtleSimple matchAll: frac with: #start withArgs:{60. 1}.

"Sierpinski triangle"

|tree frac|
tree := LSystem matchAll: '7; F=F--F--F--G; G=GG; F--F--F' with: #start. 
frac := LSystemGen matchAll: tree with: #gen.
TurtleSimple matchAll: frac with: #start withArgs:{120. 10}.

"Sierpinski curve"

|tree frac|
tree := LSystem matchAll: '5; A=B-A-B; B=A+B+A; A' with: #start. 
frac := LSystemGen matchAll: tree with: #gen.
TurtleSimple matchAll: frac with: #start withArgs:{60. 10}.

"Dragon"

|tree frac|
tree := LSystem matchAll: '10; X=X+YF+; Y=-FX-Y; FX' with: #start. 
frac := LSystemGen matchAll: tree with: #gen.
TurtleSimple matchAll: frac with: #start withArgs:{90. 5}.


LSystem drawFromCol: frac line: 10 angle: 60.
!

!LSystem class methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 00:34'!
draw: aString

	|pen sym lineLength angle|

	pen := Pen new.
	lineLength := 20.
	angle := 60.

	1 to: aString size do:[:each|
		sym := (aString at: each) asString.
		((sym = 'F') or:[(sym = 'G')]) ifTrue:[
			pen go: lineLength.
			].
	
		(sym = '+')  ifTrue:[ pen turn: angle].
		(sym = '-')  ifTrue:[ pen turn: (-1)*angle].
	].! !

!LSystem class methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 00:37'!
drawFromCol: aCol

	|pen sym lineLength angle|

	pen := Pen new.
	lineLength := 5.
	angle := 120.

	1 to: aCol size do:[:each|
		sym := (aCol at: each).
		((sym = $F) or:[(sym = $G)]) ifTrue:[
			pen go: lineLength.
			].
	
		(sym = $+)  ifTrue:[ pen turn: angle].
		(sym = $-)  ifTrue:[ pen turn: (-1)*angle].
	].! !

!LSystem class methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 14:17'!
drawFromCol: aCol line: aWidth angle: angle

	|pen sym |

	pen := Pen new.

	1 to: aCol size do:[:each|
		sym := (aCol at: each).
		(sym isLetter) ifTrue:[
			pen go: aWidth.
			].
	
		(sym = $+)  ifTrue:[ pen turn: angle].
		(sym = $-)  ifTrue:[ pen turn: (-1)*angle].
	].! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:21'!
applyRule=
	"F":n -> [self rule] 
| symbols
! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/14/2014 01:59'!
readRule=
	letter:n -> [n]
	| symbols
	! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 14:29'!
start=
	<digit*>:d ";" spaces
	letter:f "=" spaces readRule*:a ";" spaces
	letter:g "=" spaces readRule*:b ";" spaces
	readRule*:n spaces -> [{d asNumber. {{f asCharacter. a}. {g asCharacter.  b}}.  n}]
	

! !

!LSystem methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 13:33'!
symbols=
	("-" | "+"):n -> [n asCharacter] ! !

OMeta2 subclass: #LSystemGen
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2-Exp'!

!LSystemGen commentStamp: 'sn 9/16/2014 12:21' prior: 0!
LSystem matchAll: 'I: 2; F: F--F--F--G; G: GG; LS: F--F--F' with: #start. 
LSystemGen matchAll: {3. {$F. #($c $+ $F)}. #($F $G $- $G)} with: #testRule.

"sierpinski triangle"
'F': 'F--F--F--G'  {$F. #($F $- $- $F $- $- $F $- $- $G)}
'G': 'GG'		{$G. #($G $G)}
'F--F--F'        #($F $- $- $F $- $- $F)

|triangle|
triangle := LSystemGen matchAll: {3. { {$F. #($F $- $- $F $- $- $F $- $- $G)}.  {$G. #($G $G)}}. #($F $- $- $F $- $- $F)} with: #testRule.
LSystem drawFromCol: triangle.!

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 19:16'!
flatCollection: aCol
	
	^aCol gather:[:each| 
	each select:[:c| c isCharacter]
] ! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 14:31'!
gen 0 {rules} {line}:t = [t],
	gen _:n _:g takeRule(g):k= gen(n-1. g. k):m -> [m]! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 17:59'!
line=
	(letter | symbols)*! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 19:48'!
rules=
	{letter {line}}*! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 12:58'!
selectRule: aRules for: aChar
	
		|rules|
		rules := aRules select:[:each| 
			(each first = aChar)].
 		rules ifNotEmpty:[^rules first second].
		^{aChar}

	! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/15/2014 17:49'!
symbols=
	($- | $+):n -> [n asCharacter]! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 13:01'!
takeRule :g =
	{takeRuleFor(g)*:m} -> [self flatCollection: m ]! !

!LSystemGen methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 13:01'!
takeRuleFor :g =
	letter:k -> [self selectRule: g for: k]
| symbols:n -> [{n asCharacter}]! !

OMeta2 subclass: #LSystemGenExp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2-Exp'!

!LSystemGenExp methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 01:34'!
matchRule :k=
	{letter:n anything:m} ?[k=n] -> [m]
| {letter:n anything:m} -> [{}]! !

!LSystemGenExp methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 01:27'!
matchRules :k =
	matchRule(k)*:m -> [m]
	! !

!LSystemGenExp methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 13:02'!
takeRuleSingle :g =
	letter:k ?[k=g first first] -> [g first second]
| letter:k -> [{k}]
| symbols:n -> [{n asCharacter}]! !

OMeta2 subclass: #TurtleGraphic
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OMeta2-Exp'!

!TurtleGraphic commentStamp: 'sn 9/16/2014 14:54' prior: 0!
ometa LogoTranslator <: Parser {
  name         = spaces <letter (letter | digit)*>,
  cmdName      = name:n
                   ?(n !!= 'to') ?(n !!= 'end') ?(n !!= 'output') -> n,
  number       = spaces <digit+>,
  arg          = ":" name,
  cmds         = cmd*:xs                                       -> xs.delimWith(';').join(''),
  block        = "[" cmds:xs "]"                               -> ('(function() {' + xs + '})'),
  primExpr     = arg | number | block | "(" (expr | cmd):x ")" -> x,
  mulExpr      = mulExpr:x "*" primExpr:y                      -> (x + '*' + y)
               | mulExpr:x "/" primExpr:y                      -> (x + '/' + y)
               | primExpr,
  addExpr      = addExpr:x "+" mulExpr:y                       -> (x + '+' + y)
               | addExpr:x "-" mulExpr:y                       -> (x + '-' + y)
               | mulExpr,
  relExpr      = addExpr:x "<"  addExpr:y                      -> (x + '<'  + y)
               | addExpr:x "<=" addExpr:y                      -> (x + '<=' + y)
               | addExpr:x ">"  addExpr:y                      -> (x + '>'  + y)
               | addExpr:x ">=" addExpr:y                      -> (x + '>=' + y)
               | addExpr,
  expr         = relExpr,
  cmd          = "output" expr:x                               -> ('return ' + x)
               | cmdName:n expr*:args                          -> ('_this["' + n + '"].apply(_this, [' +
                                                                       args.delimWith(',').join('') + '])'),
  decl         = "to" cmdName:n arg*:args cmds:body  "end"     -> ('_this["' + n + '"]=function(' +
                                                                       args.delimWith(',').join('') + '){' + body + '}'),
  topLevelCmd  = decl | cmd,
  topLevelCmds = topLevelCmd*:xs spaces end                    -> ('(function(){var _this=this;' +
                                                                       xs.delimWith(',').join('') +
                                                                       '}).apply(smiley)')
}!

!TurtleGraphic methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 15:27'!
addExpr= 
		addExpr:x "+" mulExpr:y   -> [x, '+', y]
| addExpr:x "-" mulExpr:y    -> [x, '-', y]
| mulExpr! !

!TurtleGraphic methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 14:57'!
arg=
	":" name! !

!TurtleGraphic methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 15:21'!
block=
	"[" cmds:xs "]"	-> ['[',xs asString, ']']! !

!TurtleGraphic methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 15:24'!
cmdName name:n=
	?[n !!= 'to']
	?[n !!= 'end']
	?[n !!= 'output'] -> [n]	! !

!TurtleGraphic methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 15:02'!
cmds=
	cmd*:xs	-> [self joinStrings: xs with:';']! !

!TurtleGraphic methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 15:28'!
expr= 
	relExpr! !

!TurtleGraphic methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 15:02'!
joinStrings: strs with: sep

	^ String streamContents: [:buf | strs
									 	  			do: [:str | buf nextPutAll: str]
							 	  					separatedBy: [buf nextPutAll: sep]]! !

!TurtleGraphic methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 15:26'!
mulExpr=   
	mulExpr:x "*" primExpr:y     -> [x, '*', y]
| mulExpr:x "/" primExpr:y  -> [x, '/', y]
| primExpr! !

!TurtleGraphic methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 14:55'!
name=
	spaces <letter (letter | digit)*>! !

!TurtleGraphic methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 14:57'!
number=
	spaces <digit+>! !

!TurtleGraphic methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 15:22'!
primExpr=
	arg | number | block | "(" (expr | cmd):x ")" -> [x]! !

!TurtleGraphic methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 15:28'!
relExpr=
		addExpr:x "<"  addExpr:y   -> [x, '<' , y]
| addExpr:x "<=" addExpr:y  -> [x, '<=' , y]
| addExpr:x ">"  addExpr:y  -> [x, '>' , y]
| addExpr:x ">=" addExpr:y   -> [x, '>=' , y]
| addExpr! !

OMeta2 subclass: #TurtleSimple
	instanceVariableNames: ''
	classVariableNames: 'Turtle'
	poolDictionaries: ''
	category: 'OMeta2-Exp'!

!TurtleSimple class methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 15:54'!
initialize
	"self initialize."
	Turtle := Pen new.! !

!TurtleSimple methodsFor: 'as yet unclassified' stamp: 'sn 9/16/2014 16:07'!
start :angle :line=
	(letter -> [Turtle go: line]
| $+ -> [Turtle turn: angle]
| $- -> [Turtle turn: ((-1)*angle)])*! !
TurtleSimple initialize!
